/*
* my timer.c
*
* Created: 17.01.2024 20:42:06
* Author : amart
*/

#define F_CPU 8000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <util/atomic.h>
#include <stdlib.h>
#include <avr/sleep.h>
#include <avr/cpufunc.h>
#include "n5110.h"

//-------------------------------------------------------------------------------------------------------------------------
//     
volatile uint32_t dmilliseconds = 0;
volatile uint32_t seconds_on_tiki = 0;
volatile uint32_t milliseconds = 0;
volatile uint32_t seconds = 0;
volatile uint32_t tens_of_seconds = 0;
volatile uint32_t minutes = 0;
volatile uint32_t tens_of_minutes = 0;
volatile uint32_t time_in_sec = 0;
volatile uint32_t time_in_thensec = 0;
volatile uint32_t time_in_min = 0;
volatile uint32_t time_in_thenmin = 0;
unsigned int milis = 0;
volatile uint8_t  timer_state = 0;
volatile int  iterator =1;
volatile int  count =0,count_line =0;
volatile int  x1 =0, y1 =0, x2 =0, y2 =0;
char line = PIXEL_ON;

//-------------------------------------------------------------------------------------------------------------------------
void time (unsigned int tiki)							//     5    
{
	seconds_on_tiki = tiki / 10; //    tiki
	dmilliseconds = tiki % 10; //    (0..9)
	
	minutes = seconds_on_tiki / 60; //  (0..99)
	seconds = seconds_on_tiki % 60; //  (0..59)
	
	tens_of_minutes = minutes /10; // 
	time_in_min = minutes %10; // 
	
	tens_of_seconds = seconds/10;
	time_in_sec = seconds %10;
}

void display_timer_state(void)
{
	if (timer_state == 1)
	{
		// Timer is ON
		Lcd_print(0, 3, FONT_1X, (unsigned char *)PSTR("timer ON"));

	}
	else
	{
		// Timer is paused
		Lcd_print(0, 3, FONT_1X, (unsigned char *)PSTR("timer pause"));
		
		
	}
}
//-------------------------------------------------------------------------------------------------------------------------
void timer1_ini(void)									//   
{
	TCNT1 = 0;											//   
	OCR1A = 3125;										//       
	TIMSK |= (1<<OCIE1A);								//      OCR1A
}
//-------------------------------------------------------------------------------------------------------------------------
void timer1_start(void)									//       256   
{
	TCCR1B |= (1<<WGM12)|(1<<CS12);
}
//-------------------------------------------------------------------------------------------------------------------------
void timer1_stop(void)                                  //  
{
	TCCR1B &= ~((1<<WGM12)|(1<<CS12));
}
//-------------------------------------------------------------------------------------------------------------------------
ISR(TIMER1_COMPA_vect)									//    
{
	if (--milis==0)
	{
		TCCR1B &=~(1<<CS12);
		milis = 0;
		//PORTD |= (1<<0);

	}
}
//-------------------------------------------------------------------------------------------------------------------------
void button_on(void)									//   D    ,    
{
	DDRD = 0x00;
	PORTD |= (1<<0) | (1<<1) | (1<<2) | (1<<3);
}
//-------------------------------------------------------------------------------------------------------------------------
void displey_start(void)									//   B  ,      
{
	DDRB &= ~((1<<PINB0) | (1<<PINB1) | (1<<PINB2) | (1<<PINB3) | (1<<PINB4) | (1<<PINB5));
	PORTB = 0x00;
	Lcd_init();
	Lcd_clear();
	Lcd_update();
	LcdContrast(62);
}

ISR(INT0_vect)
{
	//    iterator     
	if (count==1) iterator = 10;
	if (count==2) iterator = 100;
	if (count==3) iterator = 600;
	if (count==4) iterator = 6000;
	if (count>=5) {count = 0; iterator = 1;}
}
//-------------------------------------------------------------------------------------------------------------------------
char buff[20];
int main(void)
{
	//      
	unsigned char keep_interrupt_status;
	//     
	unsigned int safe_desec;
	button_on();
	displey_start();
	timer1_ini();
	timer1_start();
	//   
	timer1_stop();
	//   INT0   
	EIMSK |= (1 << INT0); //    INT0
	EICRA |= (1 << ISC00); //  INT0      
	sei();
	while (1)
	{
		keep_interrupt_status = SREG; //   
		cli(); //  
		safe_desec = milis; //       
		SREG = keep_interrupt_status; //   

		time(safe_desec);

		//      
		buff[0] = tens_of_minutes + '0'; //   (0..9) ASCII
		buff[1] = time_in_min + '0'; //   (0..9) ASCII
		buff[2] = ':'; // 
		buff[3] = tens_of_seconds + '0'; //   (0..5) ASCII
		buff[4] = time_in_sec + '0'; //   (0..9) ASCII
		buff[5] = ':'; // 
		buff[6] = dmilliseconds + '0'; //    (0..9) ASCII
		buff[7] = '\0'; // NUL- 

		if (~PIND&(1<<4))
		{
			count++; //10, 100, 600,  6000
			count_line++;
			_delay_ms(150);
		}
		
			if (count==1) iterator = 10;
			if (count==2) iterator = 100;
			if (count==3) iterator = 600;
			if (count==4) iterator = 6000;
			if (count>=5) {count = 0; iterator = 1;}
		
		if (count_line==0) {x1=42; y1=9; x2=46; y2=9;}
		if (count_line==1) {x1=24; y1=9; x2=28; y2=9;}
		if (count_line==2) {x1=18; y1=9; x2=22; y2=9;}
		if (count_line==3) {x1=6; y1=9; x2=10; y2=9;}
		if (count_line==4) {x1=0; y1=9; x2=4; y2=9;}
		if (count_line>=5) {count_line=0; x1=42; y1=9; x2=46; y2=9;}
		
		if (~PIND&(1<<0))
		{
			milis+=iterator; //10, 100, 600,  6000

			_delay_ms(150);
		}

		if (~PIND&(1<<1))
		{
			time(milis);  //     
			if (tens_of_minutes != 0 || time_in_min != 0 || tens_of_seconds != 0 || time_in_sec != 0 || dmilliseconds != 0)
			{
				// ,         
				milis-=iterator;
				_delay_ms(150);
			}
			
			if(milis<=0) milis = 0;
			
		}
		
					if (tens_of_minutes == 0 && time_in_min == 0 && tens_of_seconds == 0 && time_in_sec == 0 && dmilliseconds == 0)
					{

						line = PIXEL_ON;
					}
		
		if (~PIND&(1<<2))
		{
			time(milis);  //     
			if (tens_of_minutes != 0 || time_in_min != 0 || tens_of_seconds != 0 || time_in_sec != 0 || dmilliseconds != 0)
			{
				// ,         
				timer1_start();
				line = PIXEL_OFF;
			}
			_delay_ms(150);
		}
		
		if (~PIND&(1<<3))
		{
			time(milis);  //     
			if (tens_of_minutes != 0 || time_in_min != 0 || tens_of_seconds != 0 || time_in_sec != 0 || dmilliseconds != 0)
			{
				// ,         
				timer1_stop();
				line = PIXEL_ON;
			}
			_delay_ms(150);
		}

		Lcd_clear();
		char buff[20];
		itoa(tens_of_minutes, buff, 10);
		Lcd_print(0, 0, FONT_1X,(unsigned char *)buff);
		
		itoa(time_in_min, buff, 10);
		Lcd_print(1, 0, FONT_1X,(unsigned char *)buff);
		Lcd_prints(2, 0, FONT_1X,(unsigned char *)PSTR(":"));
		
		itoa(tens_of_seconds, buff, 10);
		Lcd_print(3, 0, FONT_1X,(unsigned char *)buff);
		itoa(time_in_sec, buff, 10);
		Lcd_print(4, 0, FONT_1X,(unsigned char *)buff);
		Lcd_prints(5, 0, FONT_1X,(unsigned char *)PSTR(":"));
		
		itoa(dmilliseconds, buff, 10);
		Lcd_print(7, 0, FONT_1X,(unsigned char *)buff);

		Lcd_line ( x1, y1, x2, y2, line );
		Lcd_update();
		_delay_ms(50);

	}
}